function p = cdfp01(y,mu,twosided,ittest,df);
% cdf of the p-value at y, conditional on the mean mu. Assumes a N(mu,1)
% variate and tests that mu is 0 versus positive (twosided=0) or mu is non-zero (twosided=2).
% The output p is dim(y) x dim(mu)
% t=0 assumes a z-test; t=1 assumes a t-test
if nargin < 3 ;
    twosided = 0 ;
end ;

if nargin < 4 ;
    ittest = 0 ;
end ;

if size(y,1) == 1 ;
    y = y' ;
end ;

if size(mu,1) == 1 ;
    mu = mu' ;
end ;
pattern = 0*y*mu'  ;
nbin = length(y) - 1 ;
if ittest==0;
    if twosided == 0 ;
        load cdfp_z_onesided ;
        p = cdfp ;
        %         part1 =  norminv( 1 - y*ones(1,length(mu)) ,pattern, 1 + pattern) ;
        %         p = 1 - normcdf(  part1 ,  ones(length(y),1)*mu' , 1 + pattern ) ;

    else ;
        load cdfp_z_twosided ;
        p = cdfp ;
        %         part1 =  norminv( 1 - y*ones(1,length(mu))/2 ,pattern, 1 + pattern) ;
        %         p = 1 - normcdf(  part1 ,  ones(length(y),1)*mu' , 1 + pattern ) ...
        %             + normcdf(  - part1 ,  ones(length(y),1)*mu' , 1 + pattern )  ;
    end ;
elseif ittest == 1 ;
    if twosided == 0 ;
        'one-sided not available yet for t-tests'
    else ;
        if (nbin == 2000 & df == 4) ;
            load cdfp_t_df4 ;
            p = cdfp ;
        elseif (nbin == 2000 & df == 8) ;
            load cdfp_t_df20 ;
            p = cdfp ;
        elseif (nbin == 2000 & df == 20) ;
            load cdfp_t_df20 ;
            p = cdfp ;
        elseif (nbin == 5000 & df == 4) ;
            load cdfp_t_df4_nbin5000 ;
            p = cdfp ;
        elseif (nbin == 200 & df == 8) ;
            load cdfp_nbin200_t_df8 ;
            p = cdfp ;
        elseif (nbin == 200 & df == 4) ;
            load cdfp_nbin200_t_df4 ;
            p = cdfp ;
        else ;
            tt = tinv(    1-  (y*ones(1,length(mu))) /2 , df     ) ;
            p = 1- nctcdf(tt,df, ones(length(y),1)*mu' ) + nctcdf(-tt,df,ones(length(y),1)*mu' ) ;
        end ;
    end ;
end ;
