function p = pdfp(y,mu,twosided);
% Density of the p-value at y, conditional on the mean mu. Assumes a N(mu,1)
% variate and tests that mu is 0 versus positive.
% For the z-test
% Return p which is a length(y) by length(mu) matrix.

if nargin < 3 ;
    twosided = 0 ;
end ;
if size(mu,2) == 1 ;
    mu=mu' ;
end ;
if size(y,1) == 1 ;
    y = y' ;
end ;
if twosided == 0 ;
    p = exp(norminv(1-y)*mu - ones(length(y),1)*(mu.^2)/2) ;
else ;
    p =(   exp(norminv(1-y/2)*mu - ones(length(y),1)*(mu.^2)/2)...
        + exp(-norminv(1-y/2)*mu - ones(length(y),1)*(mu.^2)/2)  )/2 ;
end ;